=== src/utils/CMakeLists.txt ===
target_sources(kwin PRIVATE
    abstract_opengl_context_attribute_builder.cpp
    common.cpp
    egl_context_attribute_builder.cpp
    subsurfacemonitor.cpp
    xcbutils.cpp
)
